Index: kernel/generic/src/synch/syswaitq.c
===================================================================
--- kernel/generic/src/synch/syswaitq.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/src/synch/syswaitq.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -88,5 +88,5 @@
  * @return              Error code.
  */
-sys_errno_t sys_waitq_create(cap_waitq_handle_t *whandle)
+sys_errno_t sys_waitq_create(uspace_ptr_cap_waitq_handle_t whandle)
 {
 	waitq_t *wq = slab_alloc(waitq_cache, FRAME_ATOMIC);
Index: kernel/generic/src/syscall/copy.c
===================================================================
--- kernel/generic/src/syscall/copy.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/src/syscall/copy.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -59,5 +59,5 @@
  * @return EOK on success or an error code from @ref errno.h.
  */
-errno_t copy_from_uspace(void *dst, const void *uspace_src, size_t size)
+errno_t copy_from_uspace(void *dst, uspace_addr_t uspace_src, size_t size)
 {
 	ipl_t ipl;
@@ -68,5 +68,5 @@
 
 	if (!KERNEL_ADDRESS_SPACE_SHADOWED) {
-		if (overlaps((uintptr_t) uspace_src, size,
+		if (overlaps(uspace_src, size,
 		    KERNEL_ADDRESS_SPACE_START,
 		    KERNEL_ADDRESS_SPACE_END - KERNEL_ADDRESS_SPACE_START)) {
@@ -82,5 +82,5 @@
 	 * Check whether the address is outside the address space hole.
 	 */
-	if (overlaps((uintptr_t) uspace_src, size, ADDRESS_SPACE_HOLE_START,
+	if (overlaps(uspace_src, size, ADDRESS_SPACE_HOLE_START,
 	    ADDRESS_SPACE_HOLE_END - ADDRESS_SPACE_HOLE_START))
 		return EPERM;
@@ -110,5 +110,5 @@
  * @return 0 on success or an error code from @ref errno.h.
  */
-errno_t copy_to_uspace(void *uspace_dst, const void *src, size_t size)
+errno_t copy_to_uspace(uspace_addr_t uspace_dst, const void *src, size_t size)
 {
 	ipl_t ipl;
@@ -119,5 +119,5 @@
 
 	if (!KERNEL_ADDRESS_SPACE_SHADOWED) {
-		if (overlaps((uintptr_t) uspace_dst, size,
+		if (overlaps(uspace_dst, size,
 		    KERNEL_ADDRESS_SPACE_START,
 		    KERNEL_ADDRESS_SPACE_END - KERNEL_ADDRESS_SPACE_START)) {
@@ -133,5 +133,5 @@
 	 * Check whether the address is outside the address space hole.
 	 */
-	if (overlaps((uintptr_t) uspace_dst, size, ADDRESS_SPACE_HOLE_START,
+	if (overlaps(uspace_dst, size, ADDRESS_SPACE_HOLE_START,
 	    ADDRESS_SPACE_HOLE_END - ADDRESS_SPACE_HOLE_START))
 		return EPERM;
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -677,5 +677,5 @@
  *
  */
-_NO_TRACE static sysinfo_return_t sysinfo_get_item_uspace(void *ptr, size_t size,
+_NO_TRACE static sysinfo_return_t sysinfo_get_item_uspace(uspace_addr_t ptr, size_t size,
     bool dry_run)
 {
@@ -786,5 +786,5 @@
  *
  */
-_NO_TRACE static sysinfo_return_t sysinfo_get_keys_uspace(void *ptr, size_t size,
+_NO_TRACE static sysinfo_return_t sysinfo_get_keys_uspace(uspace_addr_t ptr, size_t size,
     bool dry_run)
 {
@@ -831,6 +831,6 @@
  *
  */
-sys_errno_t sys_sysinfo_get_keys_size(void *path_ptr, size_t path_size,
-    void *size_ptr)
+sys_errno_t sys_sysinfo_get_keys_size(uspace_addr_t path_ptr, size_t path_size,
+    uspace_addr_t size_ptr)
 {
 	errno_t rc;
@@ -879,6 +879,6 @@
  *
  */
-sys_errno_t sys_sysinfo_get_keys(void *path_ptr, size_t path_size,
-    void *buffer_ptr, size_t buffer_size, size_t *size_ptr)
+sys_errno_t sys_sysinfo_get_keys(uspace_addr_t path_ptr, size_t path_size,
+    uspace_addr_t buffer_ptr, size_t buffer_size, uspace_ptr_size_t size_ptr)
 {
 	errno_t rc;
@@ -914,5 +914,5 @@
  *
  */
-sysarg_t sys_sysinfo_get_val_type(void *path_ptr, size_t path_size)
+sysarg_t sys_sysinfo_get_val_type(uspace_addr_t path_ptr, size_t path_size)
 {
 	/*
@@ -950,6 +950,6 @@
  *
  */
-sys_errno_t sys_sysinfo_get_value(void *path_ptr, size_t path_size,
-    void *value_ptr)
+sys_errno_t sys_sysinfo_get_value(uspace_addr_t path_ptr, size_t path_size,
+    uspace_addr_t value_ptr)
 {
 	errno_t rc;
@@ -986,6 +986,6 @@
  *
  */
-sys_errno_t sys_sysinfo_get_data_size(void *path_ptr, size_t path_size,
-    void *size_ptr)
+sys_errno_t sys_sysinfo_get_data_size(uspace_addr_t path_ptr, size_t path_size,
+    uspace_addr_t size_ptr)
 {
 	errno_t rc;
@@ -1036,6 +1036,6 @@
  *
  */
-sys_errno_t sys_sysinfo_get_data(void *path_ptr, size_t path_size,
-    void *buffer_ptr, size_t buffer_size, size_t *size_ptr)
+sys_errno_t sys_sysinfo_get_data(uspace_addr_t path_ptr, size_t path_size,
+    uspace_addr_t buffer_ptr, size_t buffer_size, uspace_ptr_size_t size_ptr)
 {
 	errno_t rc;
Index: kernel/generic/src/udebug/udebug.c
===================================================================
--- kernel/generic/src/udebug/udebug.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/src/udebug/udebug.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -141,5 +141,5 @@
 		TASK->udebug.begin_call = NULL;
 
-		IPC_SET_RETVAL(db_call->data, 0);
+		ipc_set_retval(&db_call->data, 0);
 		ipc_answer(&TASK->answerbox, db_call);
 	} else if (TASK->udebug.dt_state == UDEBUG_TS_ACTIVE) {
@@ -160,6 +160,6 @@
 			assert(go_call);
 
-			IPC_SET_RETVAL(go_call->data, 0);
-			IPC_SET_ARG1(go_call->data, UDEBUG_EVENT_STOP);
+			ipc_set_retval(&go_call->data, 0);
+			ipc_set_arg1(&go_call->data, UDEBUG_EVENT_STOP);
 
 			THREAD->udebug.cur_event = UDEBUG_EVENT_STOP;
@@ -243,8 +243,8 @@
 	THREAD->udebug.go_call = NULL;
 
-	IPC_SET_RETVAL(call->data, 0);
-	IPC_SET_ARG1(call->data, etype);
-	IPC_SET_ARG2(call->data, id);
-	IPC_SET_ARG3(call->data, rc);
+	ipc_set_retval(&call->data, 0);
+	ipc_set_arg1(&call->data, etype);
+	ipc_set_arg2(&call->data, id);
+	ipc_set_arg3(&call->data, rc);
 
 	THREAD->udebug.syscall_args[0] = a1;
@@ -314,7 +314,7 @@
 
 	THREAD->udebug.go_call = NULL;
-	IPC_SET_RETVAL(call->data, 0);
-	IPC_SET_ARG1(call->data, UDEBUG_EVENT_THREAD_B);
-	IPC_SET_ARG2(call->data, (sysarg_t) thread);
+	ipc_set_retval(&call->data, 0);
+	ipc_set_arg1(&call->data, UDEBUG_EVENT_THREAD_B);
+	ipc_set_arg2(&call->data, (sysarg_t) thread);
 
 	/*
@@ -365,6 +365,6 @@
 
 	THREAD->udebug.go_call = NULL;
-	IPC_SET_RETVAL(call->data, 0);
-	IPC_SET_ARG1(call->data, UDEBUG_EVENT_THREAD_E);
+	ipc_set_retval(&call->data, 0);
+	ipc_set_arg1(&call->data, UDEBUG_EVENT_THREAD_E);
 
 	/* Prevent any further debug activity in thread. */
@@ -428,6 +428,6 @@
 				LOG("Answer GO call with EVENT_FINISHED.");
 
-				IPC_SET_RETVAL(thread->udebug.go_call->data, 0);
-				IPC_SET_ARG1(thread->udebug.go_call->data,
+				ipc_set_retval(&thread->udebug.go_call->data, 0);
+				ipc_set_arg1(&thread->udebug.go_call->data,
 				    UDEBUG_EVENT_FINISHED);
 
Index: kernel/generic/src/udebug/udebug_ipc.c
===================================================================
--- kernel/generic/src/udebug/udebug_ipc.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/src/udebug/udebug_ipc.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -53,5 +53,5 @@
 errno_t udebug_request_preprocess(call_t *call, phone_t *phone)
 {
-	switch (IPC_GET_ARG1(call->data)) {
+	switch (ipc_get_arg1(&call->data)) {
 		/* future UDEBUG_M_REGS_WRITE, UDEBUG_M_MEM_WRITE: */
 	default:
@@ -76,5 +76,5 @@
 	rc = udebug_begin(call, &active);
 	if (rc != EOK) {
-		IPC_SET_RETVAL(call->data, rc);
+		ipc_set_retval(&call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
 		return;
@@ -86,5 +86,5 @@
 	 */
 	if (active) {
-		IPC_SET_RETVAL(call->data, EOK);
+		ipc_set_retval(&call->data, EOK);
 		ipc_answer(&TASK->kb.box, call);
 	}
@@ -102,5 +102,5 @@
 	rc = udebug_end();
 
-	IPC_SET_RETVAL(call->data, rc);
+	ipc_set_retval(&call->data, rc);
 	ipc_answer(&TASK->kb.box, call);
 }
@@ -116,8 +116,8 @@
 	udebug_evmask_t mask;
 
-	mask = IPC_GET_ARG2(call->data);
+	mask = ipc_get_arg2(&call->data);
 	rc = udebug_set_evmask(mask);
 
-	IPC_SET_RETVAL(call->data, rc);
+	ipc_set_retval(&call->data, rc);
 	ipc_answer(&TASK->kb.box, call);
 }
@@ -133,9 +133,9 @@
 	errno_t rc;
 
-	t = (thread_t *)IPC_GET_ARG2(call->data);
+	t = (thread_t *)ipc_get_arg2(&call->data);
 
 	rc = udebug_go(t, call);
 	if (rc != EOK) {
-		IPC_SET_RETVAL(call->data, rc);
+		ipc_set_retval(&call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
 		return;
@@ -153,8 +153,8 @@
 	errno_t rc;
 
-	t = (thread_t *)IPC_GET_ARG2(call->data);
+	t = (thread_t *)ipc_get_arg2(&call->data);
 
 	rc = udebug_stop(t, call);
-	IPC_SET_RETVAL(call->data, rc);
+	ipc_set_retval(&call->data, rc);
 	ipc_answer(&TASK->kb.box, call);
 }
@@ -173,6 +173,6 @@
 	errno_t rc;
 
-	uspace_addr = IPC_GET_ARG2(call->data);	/* Destination address */
-	buf_size = IPC_GET_ARG3(call->data);	/* Dest. buffer size */
+	uspace_addr = ipc_get_arg2(&call->data);	/* Destination address */
+	buf_size = ipc_get_arg3(&call->data);	/* Dest. buffer size */
 
 	/*
@@ -182,5 +182,5 @@
 	rc = udebug_thread_read(&buffer, buf_size, &copied, &needed);
 	if (rc != EOK) {
-		IPC_SET_RETVAL(call->data, rc);
+		ipc_set_retval(&call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
 		return;
@@ -191,13 +191,13 @@
 	 */
 
-	IPC_SET_RETVAL(call->data, 0);
-	/*
-	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
-	 * same code in process_answer() can be used
-	 * (no way to distinguish method in answer)
-	 */
-	IPC_SET_ARG1(call->data, uspace_addr);
-	IPC_SET_ARG2(call->data, copied);
-	IPC_SET_ARG3(call->data, needed);
+	ipc_set_retval(&call->data, 0);
+	/*
+	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
+	 * same code in process_answer() can be used
+	 * (no way to distinguish method in answer)
+	 */
+	ipc_set_arg1(&call->data, uspace_addr);
+	ipc_set_arg2(&call->data, copied);
+	ipc_set_arg3(&call->data, needed);
 	call->buffer = buffer;
 
@@ -219,6 +219,6 @@
 	void *data;
 
-	uspace_addr = IPC_GET_ARG2(call->data);	/* Destination address */
-	buf_size = IPC_GET_ARG3(call->data);	/* Dest. buffer size */
+	uspace_addr = ipc_get_arg2(&call->data);	/* Destination address */
+	buf_size = ipc_get_arg3(&call->data);	/* Dest. buffer size */
 
 	/*
@@ -238,14 +238,14 @@
 	 */
 
-	IPC_SET_RETVAL(call->data, 0);
-	/*
-	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
-	 * same code in process_answer() can be used
-	 * (no way to distinguish method in answer)
-	 */
-	IPC_SET_ARG1(call->data, uspace_addr);
-	IPC_SET_ARG2(call->data, to_copy);
-
-	IPC_SET_ARG3(call->data, data_size);
+	ipc_set_retval(&call->data, 0);
+	/*
+	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
+	 * same code in process_answer() can be used
+	 * (no way to distinguish method in answer)
+	 */
+	ipc_set_arg1(&call->data, uspace_addr);
+	ipc_set_arg2(&call->data, to_copy);
+
+	ipc_set_arg3(&call->data, data_size);
 	call->buffer = data;
 
@@ -268,6 +268,6 @@
 	as_area_info_t *data;
 
-	uspace_addr = IPC_GET_ARG2(call->data);	/* Destination address */
-	buf_size = IPC_GET_ARG3(call->data);	/* Dest. buffer size */
+	uspace_addr = ipc_get_arg2(&call->data);	/* Destination address */
+	buf_size = ipc_get_arg3(&call->data);	/* Dest. buffer size */
 
 	/*
@@ -276,5 +276,5 @@
 	data = as_get_area_info(AS, &data_size);
 	if (!data) {
-		IPC_SET_RETVAL(call->data, ENOMEM);
+		ipc_set_retval(&call->data, ENOMEM);
 		ipc_answer(&TASK->kb.box, call);
 		return;
@@ -292,14 +292,14 @@
 	 */
 
-	IPC_SET_RETVAL(call->data, 0);
-	/*
-	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
-	 * same code in process_answer() can be used
-	 * (no way to distinguish method in answer)
-	 */
-	IPC_SET_ARG1(call->data, uspace_addr);
-	IPC_SET_ARG2(call->data, to_copy);
-
-	IPC_SET_ARG3(call->data, data_size);
+	ipc_set_retval(&call->data, 0);
+	/*
+	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
+	 * same code in process_answer() can be used
+	 * (no way to distinguish method in answer)
+	 */
+	ipc_set_arg1(&call->data, uspace_addr);
+	ipc_set_arg2(&call->data, to_copy);
+
+	ipc_set_arg3(&call->data, data_size);
 	call->buffer = (uint8_t *) data;
 
@@ -319,9 +319,9 @@
 	void *buffer;
 
-	t = (thread_t *)IPC_GET_ARG2(call->data);
+	t = (thread_t *)ipc_get_arg2(&call->data);
 
 	rc = udebug_args_read(t, &buffer);
 	if (rc != EOK) {
-		IPC_SET_RETVAL(call->data, rc);
+		ipc_set_retval(&call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
 		return;
@@ -332,14 +332,14 @@
 	 */
 
-	uspace_addr = IPC_GET_ARG3(call->data);
-
-	IPC_SET_RETVAL(call->data, 0);
-	/*
-	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
-	 * same code in process_answer() can be used
-	 * (no way to distinguish method in answer)
-	 */
-	IPC_SET_ARG1(call->data, uspace_addr);
-	IPC_SET_ARG2(call->data, 6 * sizeof(sysarg_t));
+	uspace_addr = ipc_get_arg3(&call->data);
+
+	ipc_set_retval(&call->data, 0);
+	/*
+	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
+	 * same code in process_answer() can be used
+	 * (no way to distinguish method in answer)
+	 */
+	ipc_set_arg1(&call->data, uspace_addr);
+	ipc_set_arg2(&call->data, 6 * sizeof(sysarg_t));
 	call->buffer = buffer;
 
@@ -359,9 +359,9 @@
 	errno_t rc;
 
-	t = (thread_t *) IPC_GET_ARG2(call->data);
+	t = (thread_t *) ipc_get_arg2(&call->data);
 
 	rc = udebug_regs_read(t, &buffer);
 	if (rc != EOK) {
-		IPC_SET_RETVAL(call->data, rc);
+		ipc_set_retval(&call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
 		return;
@@ -374,15 +374,15 @@
 	 */
 
-	uspace_addr = IPC_GET_ARG3(call->data);
+	uspace_addr = ipc_get_arg3(&call->data);
 	to_copy = sizeof(istate_t);
 
-	IPC_SET_RETVAL(call->data, 0);
-	/*
-	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
-	 * same code in process_answer() can be used
-	 * (no way to distinguish method in answer)
-	 */
-	IPC_SET_ARG1(call->data, uspace_addr);
-	IPC_SET_ARG2(call->data, to_copy);
+	ipc_set_retval(&call->data, 0);
+	/*
+	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
+	 * same code in process_answer() can be used
+	 * (no way to distinguish method in answer)
+	 */
+	ipc_set_arg1(&call->data, uspace_addr);
+	ipc_set_arg2(&call->data, to_copy);
 
 	call->buffer = buffer;
@@ -398,17 +398,17 @@
 static void udebug_receive_mem_read(call_t *call)
 {
-	sysarg_t uspace_dst;
-	sysarg_t uspace_src;
+	uspace_addr_t uspace_dst;
+	uspace_addr_t uspace_src;
 	unsigned size;
 	void *buffer = NULL;
 	errno_t rc;
 
-	uspace_dst = IPC_GET_ARG2(call->data);
-	uspace_src = IPC_GET_ARG3(call->data);
-	size = IPC_GET_ARG4(call->data);
+	uspace_dst = ipc_get_arg2(&call->data);
+	uspace_src = ipc_get_arg3(&call->data);
+	size = ipc_get_arg4(&call->data);
 
 	rc = udebug_mem_read(uspace_src, size, &buffer);
 	if (rc != EOK) {
-		IPC_SET_RETVAL(call->data, rc);
+		ipc_set_retval(&call->data, rc);
 		ipc_answer(&TASK->kb.box, call);
 		return;
@@ -417,12 +417,12 @@
 	assert(buffer != NULL);
 
-	IPC_SET_RETVAL(call->data, 0);
-	/*
-	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
-	 * same code in process_answer() can be used
-	 * (no way to distinguish method in answer)
-	 */
-	IPC_SET_ARG1(call->data, uspace_dst);
-	IPC_SET_ARG2(call->data, size);
+	ipc_set_retval(&call->data, 0);
+	/*
+	 * ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
+	 * same code in process_answer() can be used
+	 * (no way to distinguish method in answer)
+	 */
+	ipc_set_arg1(&call->data, uspace_dst);
+	ipc_set_arg2(&call->data, size);
 	call->buffer = buffer;
 
@@ -439,5 +439,5 @@
 	int debug_method;
 
-	debug_method = IPC_GET_ARG1(call->data);
+	debug_method = ipc_get_arg1(&call->data);
 
 	if (debug_method != UDEBUG_M_BEGIN) {
@@ -450,5 +450,5 @@
 		 */
 		if (TASK->udebug.debugger != call->sender) {
-			IPC_SET_RETVAL(call->data, EINVAL);
+			ipc_set_retval(&call->data, EINVAL);
 			ipc_answer(&TASK->kb.box, call);
 			return;
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -328,6 +328,6 @@
 	thread->udebug.go_call = NULL;
 
-	IPC_SET_RETVAL(call->data, 0);
-	IPC_SET_ARG1(call->data, UDEBUG_EVENT_STOP);
+	ipc_set_retval(&call->data, 0);
+	ipc_set_arg1(&call->data, UDEBUG_EVENT_STOP);
 
 	THREAD->udebug.cur_event = UDEBUG_EVENT_STOP;
@@ -548,5 +548,5 @@
  *
  */
-errno_t udebug_mem_read(sysarg_t uspace_addr, size_t n, void **buffer)
+errno_t udebug_mem_read(uspace_addr_t uspace_addr, size_t n, void **buffer)
 {
 	/* Verify task state */
@@ -569,5 +569,5 @@
 	 *
 	 */
-	errno_t rc = copy_from_uspace(data_buffer, (void *) uspace_addr, n);
+	errno_t rc = copy_from_uspace(data_buffer, uspace_addr, n);
 	mutex_unlock(&TASK->udebug.lock);
 
Index: release/Makefile
===================================================================
--- release/Makefile	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ release/Makefile	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -39,4 +39,5 @@
 	arm32/integratorcp \
 	arm32/raspberrypi \
+	arm64/virt \
 	ia32 \
 	ia64/i460GX \
Index: tools/autocheck.awk
===================================================================
--- tools/autocheck.awk	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ tools/autocheck.awk	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -33,6 +33,11 @@
 BEGIN {
 	filename = ARGV[1]
+	output_lines = 0
 	print "// Generated file. Fix the included header if static assert fails."
-	print "#include \"" filename "\""
+	print "// Inlined \"" filename "\""
+}
+
+{
+	print $0
 }
 
@@ -44,5 +49,5 @@
 	}
 	macro_name = toupper(struct_name) "_SIZE"
-	print "_Static_assert(" macro_name " == sizeof(struct " struct_name "), \"\");"
+	output[output_lines++] = "_Static_assert(" macro_name " == sizeof(struct " struct_name "), \"\");"
 	struct_name = ""
 }
@@ -55,10 +60,10 @@
 
 		macro_name = toupper(struct_name) "_OFFSET_" toupper(member)
-		print "_Static_assert(" macro_name " == __builtin_offsetof(struct " struct_name ", " member "), \"\");"
+		output[output_lines++] = "_Static_assert(" macro_name " == __builtin_offsetof(struct " struct_name ", " member "), \"\");"
 
 		macro_name = toupper(struct_name) "_SIZE_" toupper(member)
-		print "#ifdef " macro_name
-		print "_Static_assert(" macro_name " == sizeof(((struct " struct_name "){ })." member "), \"\");"
-		print "#endif"
+		output[output_lines++] = "#ifdef " macro_name
+		output[output_lines++] = "_Static_assert(" macro_name " == sizeof(((struct " struct_name "){ })." member "), \"\");"
+		output[output_lines++] = "#endif"
 	}
 }
@@ -67,2 +72,8 @@
 	struct_name = $3
 }
+
+END {
+	for ( i = 0; i < output_lines; i++ ) {
+		print output[i]
+	}
+}
Index: tools/autotool.py
===================================================================
--- tools/autotool.py	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ tools/autotool.py	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -201,4 +201,8 @@
 		target = "arm-helenos"
 
+	if (config['PLATFORM'] == "arm64"):
+		platform = config['PLATFORM']
+		target = "aarch64-helenos"
+
 	if (config['PLATFORM'] == "ia32"):
 		platform = config['PLATFORM']
@@ -633,5 +637,5 @@
 
 		# Platform-specific utilities
-		if ((config['BARCH'] == "amd64") or (config['BARCH'] == "ia32") or (config['BARCH'] == "ppc32") or (config['BARCH'] == "sparc64")):
+		if (config['BARCH'] in ('amd64', 'arm64', 'ia32', 'ppc32', 'sparc64')):
 			common['GENISOIMAGE'] = check_app_alternatives(["genisoimage", "mkisofs", "xorriso"], ["--version"], "ISO 9660 creation utility", "usually part of genisoimage")
 			if common['GENISOIMAGE'] == 'xorriso':
Index: tools/build-ccheck.sh
===================================================================
--- tools/build-ccheck.sh	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ tools/build-ccheck.sh	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -29,5 +29,5 @@
 
 SYCEK_GIT="https://github.com/jxsvoboda/sycek"
-SYCEK_REV="eaa42806e3894fb41ba6bd79fab96e1ae8720f29"
+SYCEK_REV="4dc1760741efdd84506478ab6effd68812b4726a"
 
 if [ ! -d sycek ]; then
Index: tools/config.py
===================================================================
--- tools/config.py	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ tools/config.py	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -42,8 +42,155 @@
 import random
 
-RULES_FILE = sys.argv[1]
+ARGPOS_RULES = 1
+ARGPOS_CHOICE = 2
+ARGPOS_PRESET = 3
+
+RULES_FILE = sys.argv[ARGPOS_RULES]
 MAKEFILE = 'Makefile.config'
 MACROS = 'config.h'
 PRESETS_DIR = 'defaults'
+
+class BinaryOp:
+	def __init__(self, operator, left, right):
+		assert operator in ('&', '|', '=', '!=')
+
+		self._operator = operator
+		self._left = left
+		self._right = right
+
+	def evaluate(self, config):
+		if self._operator == '&':
+			return self._left.evaluate(config) and \
+			    self._right.evaluate(config)
+		if self._operator == '|':
+			return self._left.evaluate(config) or \
+			    self._right.evaluate(config)
+
+		# '=' or '!='
+		if not self._left in config:
+			config_val = ''
+		else:
+			config_val = config[self._left]
+			if config_val == '*':
+				config_val = 'y'
+
+		if self._operator == '=':
+			return self._right == config_val
+		return self._right != config_val
+
+# Expression parser
+class CondParser:
+	TOKEN_EOE = 0
+	TOKEN_SPECIAL = 1
+	TOKEN_STRING = 2
+
+	def __init__(self, text):
+		self._text = text
+
+	def parse(self):
+		self._position = -1
+		self._next_char()
+		self._next_token()
+
+		res = self._parse_expr()
+		if self._token_type != self.TOKEN_EOE:
+			self._error("Expected end of expression")
+		return res
+
+	def _next_char(self):
+		self._position += 1
+		if self._position >= len(self._text):
+			self._char = None
+		else:
+			self._char = self._text[self._position]
+		self._is_special_char = self._char in \
+		    ('&', '|', '=', '!', '(', ')')
+
+	def _error(self, msg):
+		raise RuntimeError("Error parsing expression: %s:\n%s\n%s^" %
+		    (msg, self._text, " " * self._token_position))
+
+	def _next_token(self):
+		self._token_position = self._position
+
+		# End of expression
+		if self._char == None:
+			self._token = None
+			self._token_type = self.TOKEN_EOE
+			return
+
+		# '&', '|', '=', '!=', '(', ')'
+		if self._is_special_char:
+			self._token = self._char
+			self._next_char()
+			if self._token == '!':
+				if self._char != '=':
+					self._error("Expected '='")
+				self._token += self._char
+				self._next_char()
+			self._token_type = self.TOKEN_SPECIAL
+			return
+
+		# <var> or <val>
+		self._token = ''
+		self._token_type = self.TOKEN_STRING
+		while True:
+			self._token += self._char
+			self._next_char()
+			if self._is_special_char or self._char == None:
+				break
+
+	def _parse_expr(self):
+		""" <expr> ::= <or_expr> ('&' <or_expr>)* """
+
+		left = self._parse_or_expr()
+		while self._token == '&':
+			self._next_token()
+			left = BinaryOp('&', left, self._parse_or_expr())
+		return left
+
+	def _parse_or_expr(self):
+		""" <or_expr> ::= <factor> ('|' <factor>)* """
+
+		left = self._parse_factor()
+		while self._token == '|':
+			self._next_token()
+			left = BinaryOp('|', left, self._parse_factor())
+		return left
+
+	def _parse_factor(self):
+		""" <factor> ::= <var> <cond> | '(' <expr> ')' """
+
+		if self._token == '(':
+			self._next_token()
+			res = self._parse_expr()
+			if self._token != ')':
+				self._error("Expected ')'")
+			self._next_token()
+			return res
+
+		if self._token_type == self.TOKEN_STRING:
+			var = self._token
+			self._next_token()
+			return self._parse_cond(var)
+
+		self._error("Expected '(' or <var>")
+
+	def _parse_cond(self, var):
+		""" <cond> ::= '=' <val> | '!=' <val> """
+
+		if self._token not in ('=', '!='):
+			self._error("Expected '=' or '!='")
+
+		oper = self._token
+		self._next_token()
+
+		if self._token_type != self.TOKEN_STRING:
+			self._error("Expected <val>")
+
+		val = self._token
+		self._next_token()
+
+		return BinaryOp(oper, var, val)
 
 def read_config(fname, config):
@@ -59,76 +206,4 @@
 	inf.close()
 
-def check_condition(text, config, rules):
-	"Check that the condition specified on input line is True (only CNF and DNF is supported)"
-
-	ctype = 'cnf'
-
-	if (')|' in text) or ('|(' in text):
-		ctype = 'dnf'
-
-	if ctype == 'cnf':
-		conds = text.split('&')
-	else:
-		conds = text.split('|')
-
-	for cond in conds:
-		if cond.startswith('(') and cond.endswith(')'):
-			cond = cond[1:-1]
-
-		inside = check_inside(cond, config, ctype)
-
-		if (ctype == 'cnf') and (not inside):
-			return False
-
-		if (ctype == 'dnf') and inside:
-			return True
-
-	if ctype == 'cnf':
-		return True
-
-	return False
-
-def check_inside(text, config, ctype):
-	"Check for condition"
-
-	if ctype == 'cnf':
-		conds = text.split('|')
-	else:
-		conds = text.split('&')
-
-	for cond in conds:
-		res = re.match(r'^(.*?)(!?=)(.*)$', cond)
-		if not res:
-			raise RuntimeError("Invalid condition: %s" % cond)
-
-		condname = res.group(1)
-		oper = res.group(2)
-		condval = res.group(3)
-
-		if not condname in config:
-			varval = ''
-		else:
-			varval = config[condname]
-			if (varval == '*'):
-				varval = 'y'
-
-		if ctype == 'cnf':
-			if (oper == '=') and (condval == varval):
-				return True
-
-			if (oper == '!=') and (condval != varval):
-				return True
-		else:
-			if (oper == '=') and (condval != varval):
-				return False
-
-			if (oper == '!=') and (condval == varval):
-				return False
-
-	if ctype == 'cnf':
-		return False
-
-	return True
-
 def parse_rules(fname, rules):
 	"Parse rules file"
@@ -149,4 +224,6 @@
 
 			cond = res.group(1)
+			if cond:
+				cond = CondParser(cond).parse()
 			varname = res.group(2)
 			vartype = res.group(3)
@@ -232,5 +309,5 @@
 		varname, vartype, name, choices, cond = rule
 
-		if cond and (not check_condition(cond, config, rules)):
+		if cond and not cond.evaluate(config):
 			continue
 
@@ -279,7 +356,6 @@
 
 	# First check that this rule would make sense
-	if cond:
-		if not check_condition(cond, config, rules):
-			return random_choices(config, rules, start_index + 1)
+	if cond and not cond.evaluate(config):
+		return random_choices(config, rules, start_index + 1)
 
 	# Remember previous choices for backtracking
@@ -487,5 +563,5 @@
 
 	for varname, vartype, name, choices, cond in rules:
-		if cond and (not check_condition(cond, config, rules)):
+		if cond and not cond.evaluate(config):
 			continue
 
@@ -514,11 +590,11 @@
 	outmk.write('TIMESTAMP_UNIX = %d\n' % timestamp_unix)
 	outmc.write('#define TIMESTAMP_UNIX %d\n' % timestamp_unix)
-	defs += ' "-DTIMESTAMP_UNIX=%d"\n' % timestamp_unix
+	defs += ' "-DTIMESTAMP_UNIX=%d"' % timestamp_unix
 
 	outmk.write('TIMESTAMP = %s\n' % timestamp)
 	outmc.write('#define TIMESTAMP %s\n' % timestamp)
-	defs += ' "-DTIMESTAMP=%s"\n' % timestamp
-
-	outmk.write(defs)
+	defs += ' "-DTIMESTAMP=%s"' % timestamp
+
+	outmk.write('%s\n' % defs)
 
 	outmk.close()
@@ -604,8 +680,18 @@
 	parse_rules(RULES_FILE, rules)
 
+	if len(sys.argv) > ARGPOS_CHOICE:
+		choice = sys.argv[ARGPOS_CHOICE]
+	else:
+		choice = None
+
+	if len(sys.argv) > ARGPOS_PRESET:
+		preset = sys.argv[ARGPOS_PRESET]
+	else:
+		preset = None
+
 	# Input configuration file can be specified on command line
 	# otherwise configuration from previous run is used.
-	if len(sys.argv) >= 4:
-		profile = parse_profile_name(sys.argv[3])
+	if preset is not None:
+		profile = parse_profile_name(preset)
 		read_presets(profile, config)
 	elif os.path.exists(MAKEFILE):
@@ -613,5 +699,5 @@
 
 	# Default mode: check values and regenerate configuration files
-	if (len(sys.argv) >= 3) and (sys.argv[2] == 'default'):
+	if choice == 'default':
 		if (infer_verify_choices(config, rules)):
 			preprocess_config(config, rules)
@@ -621,8 +707,8 @@
 	# Hands-off mode: check values and regenerate configuration files,
 	# but no interactive fallback
-	if (len(sys.argv) >= 3) and (sys.argv[2] == 'hands-off'):
-		# We deliberately test sys.argv >= 4 because we do not want
+	if choice == 'hands-off':
+		# We deliberately test this because we do not want
 		# to read implicitly any possible previous run configuration
-		if len(sys.argv) < 4:
+		if preset is None:
 			sys.stderr.write("Configuration error: No presets specified\n")
 			return 2
@@ -637,5 +723,5 @@
 
 	# Check mode: only check configuration
-	if (len(sys.argv) >= 3) and (sys.argv[2] == 'check'):
+	if choice == 'check':
 		if infer_verify_choices(config, rules):
 			return 0
@@ -643,5 +729,5 @@
 
 	# Random mode
-	if (len(sys.argv) == 3) and (sys.argv[2] == 'random'):
+	if choice == 'random':
 		ok = random_choices(config, rules, 0)
 		if not ok:
@@ -676,5 +762,5 @@
 				varname, vartype, name, choices, cond = rule
 
-				if cond and (not check_condition(cond, config, rules)):
+				if cond and not cond.evaluate(config):
 					continue
 
